<?php

namespace Ems\Logic\Offline;

use Doctrine\ORM\EntityManagerInterface;
use Ems\Util\Utils;
use Ems\Services\{ MarcacaoService, ParamOrgService, OcorrenciaService };
use Util\Environment;

abstract class OfflineEntity {
    public abstract function synchronize(): void;
    
    protected function getEntityManager(): ?EntityManagerInterface {
        return Utils::getEntityManager();
    }
    
    protected function getParamters(): Environment {
        return Utils::getParamters();
    }
    
    protected function getNrorg(): int {
        return $this->getParamters()->getNrorg();
    }
    
    protected function getCdoperador(): ?string {
        return $this->getParamters()->getCdoperador();
    }
    
    protected function getOcorrenciaServiceInstance(): OcorrenciaService {
        return OcorrenciaService::getInstance();
    }
    
    protected function getMarcacaoServiceInstance(): MarcacaoService {
        return MarcacaoService::getInstance();
    }
    
    protected function getParamOrgServiceInstance(): ParamOrgService {
        return ParamOrgService::getInstance();
    }
}